/* vortex00.c -- solution in C to level 00 of the Vortex Wargame
 *               located at http://www.pulltheplug.org
 *
 * Beau Grantham (beau@thedarkmere.net)
 * 2006/04/27
 *
 * Your goal is to connect to port 5842 on vortex.labs.pulltheplug.org 
 * and read in 4 unsigned integers. Add these integers together and 
 * send back the results to get a username and password for level 1. 
 * Note that vortex is on an x86 machine (meaning, a little endian 
 * architecture).
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>

#define DEST_IP   "69.55.233.82"
#define DEST_PORT 5842

main() {
  int          i,
	       bytes = 0,
               sockfd,
               numbytes;
  char         *buf;
  struct       sockaddr_in dest_addr;
  unsigned int scan[ 4 ],
	       total = 0;

  
  /* Begin standard tcp socket initializers */
  
  sockfd                    = socket(PF_INET, SOCK_STREAM, 0);
  dest_addr.sin_family      = AF_INET; 
  dest_addr.sin_port        = htons(DEST_PORT); 
  dest_addr.sin_addr.s_addr = inet_addr(DEST_IP);
  memset(&(dest_addr.sin_zero), '\0', 8);

  /* End standard tcp socket initializers */
  

  // Connect socket, or exit on error
  if (connect(sockfd, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1) {
      perror("connect");
      exit(1);
  }

  printf("Connected to %s:%d \nScanning input... ", DEST_IP, DEST_PORT);
    
  // Scan in 4 unsigned integers
  for (i = 0; i < 4; i++) {
    // Exit if we stop receiving data
    if ((numbytes = recv(sockfd, &scan[i], sizeof(unsigned int), 0)) == -1) {
      perror("recv");
      exit(1);
    }
    total += scan[i];
    bytes += numbytes;
  }
  
  printf("%d bytes read \nSending result... ", bytes);
  
  // Send the result back, exit on error
  if ((numbytes = send(sockfd, &total, sizeof(unsigned int), 0)) == -1) {
    perror("send");
    exit(1);
  }

  printf("%d bytes sent \nFetching reply... \n", numbytes);

  // Receive our gift (or denial), exit on error
  if ((numbytes = recv(sockfd, buf, 1024, 0)) == -1) {
    perror("recv");
    exit(1);
  }      
  
  // Happy birthday to us
  printf("%s", buf);

  // Kill socket
  close(sockfd);

  return;

}
